// ProgramThree.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ProgramThree.h"
#include "GradeRecord.h"
#include "HighResolutionTime.h"
#include <afxtempl.h>
#include <fstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

// List of all student grade records
CList <CGradeRecord, CGradeRecord&> studentList;

int searchForLastName(string lastName);
void loadFile();

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		string lastName;
	
		cout << "Press ENTER to load grade record database: ";
		char c;
		cin.get(c);
		loadFile();

		cout << "Enter the last name you want to search for in the grade record database: ";
		cin  >> lastName;

		int result = searchForLastName(lastName);

		cout << "Found " << result << " occurrences of " << lastName << endl;
		cout << "Press ENTER to terminate..." << endl;
		cin.get(c);
		cin.get(c);
	}

	return nRetCode;
}

int searchForLastName(string lastName) {

	POSITION pos = studentList.GetHeadPosition();
	CGradeRecord r = studentList.GetHead();

	int result=0;

	while (pos) {
		if (r.lname == lastName) {
			result++;
		}
		r = studentList.GetNext(pos);
	}

	return result;
}

void loadFile()
{
	cout << "Loading cache file into memory." << endl;

	ifstream in;
	in.open("cacheFile");

	int count=0;
	while (!in.fail()) {
		CGradeRecord* r = new CGradeRecord();
		in >> *r;	
		studentList.AddHead(*r);
		count++;
		if ((count % 1000) == 0) {
				cout << ".";
				cout.flush();
		}
	}
	cout << endl;

	int size=studentList.GetCount();

	cout << "Cache file loaded " << size << " records." << endl;
}
